from __future__ import annotations

from pathlib import Path
from typing import Final

import axipy

from . import config
from .info import NSPDInfo
from .layers import NSPDLayers

ICON_PATH: Final[Path] = config.PATH / "images"
ICON_NAME: Final[str] = "nspd_info.png"
ICON_SIZES: Final[tuple[int, ...]] = (16, 24, 32)


class NSPD(axipy.Plugin):
    def __init__(self) -> None:
        self.nspd_layers = NSPDLayers(self)
        self.nspd_info = NSPDInfo(self)

        self._unloaded = False

    def load(self) -> None:
        self.nspd_layers.load()

    def unload(self) -> None:
        self.nspd_layers.unload()
        self.nspd_info.unload()
