import axipy
from PySide2.QtCore import Signal

from .base_tool_manager import BaseToolManager


class ToolManager(BaseToolManager):
    """
    Tool management system with dictionary-like interface.
    Supports QT signals for adding and removing tools, as well as a signal for clicking on the map.
    """

    click = Signal(str, axipy.Pnt)  # (tool_id: str, pnt: axipy.Pnt)

    def on_click(self, tool_id: str, pnt: axipy.Pnt) -> None:
        if tool_id in self:
            self.click.emit(tool_id, pnt)
